<template>
  <div>
    <div class="titleBoxs">
      <div class="title">盘查统计分析</div>
    </div>
    <div class="content-box-sun">
      <!-- 组织机构盒子 -->
      <div class="org-box">
        <div class="tree-box" :style="{ height: orgHeight + 'px' }">
          <MOSTY.DepartmentTree
            width="100%"
            placeholder="管理部门ID"
            clearable
            filterable
            v-model="listQuery.ssbmdm"
          />
        </div>
      </div>
      <div class="right-box-sun">
        <div class="chart-box">
          <div class="searchBox chart-pie-box">
            <div>盘查统计特征统计</div>
            <Pie :data="countAll" :key="keyCount" />
          </div>
        </div>
        <!-- 表格盒子 -->
        <div class="table-box">
          <div class="searchBox" ref="searchBox">
            <el-form :model="listQuery" :inline="true">
              <el-form-item label="时间段">
                <el-date-picker
                  v-model="timeRange"
                  @change="handleTime"
                  unlink-panels
                  type="daterange"
                  range-separator="至"
                  start-placeholder="开始日期"
                  end-placeholder="结束日期"
                  value-format="YYYY-M-D HH:mm:ss"
                  format="YYYY-M-D HH:mm:ss"
                />
              </el-form-item>
              <el-form-item>
                <el-button @click="handleFilter"> 查询 </el-button>
                <el-button @click="reset"> 重置 </el-button>
              </el-form-item>
            </el-form>
          </div>
          <div class="tabBox">
            <el-table
              :data="tableData"
              border
              row-key="id"
              style="width: 100%"
              :key="keyCount"
              :height="tableHeight"
              v-loading="loadingTable"
              element-loading-background="rgba(0,0,0,0.3)"
              element-loading-text="数据加载中。。"
            >
              <el-table-column
                label="序号"
                type="index"
                align="center"
                width="50"
              />
              <el-table-column
                label="单位部门"
                prop="ssbm"
                align="center"
                show-overflow-tooltip
              />
              <el-table-column label="盘查人" prop="pcry" align="center" />
              <el-table-column label="盘查车" prop="pccl" align="center" />
              <el-table-column
                label="操作"
                align="center"
                fixed="right"
                width="150px"
              >
                <template #default="{ row }">
                  <el-button @click="detail(row)" size="small">详情</el-button>
                </template>
              </el-table-column>
            </el-table>
            <div class="fenye" :style="{ top: tableHeight + 'px' }">
              <el-pagination
                class="pagination"
                @size-change="handleSizeChange"
                @current-change="handleCurrentChange"
                :current-page="listQuery.pageCurrent"
                :page-sizes="[10, 20, 50, 100]"
                :page-size="listQuery.pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="total"
              >
              </el-pagination>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="dialog" v-if="dialogFormVisible">
      <div class="head_box">
        <span class="title">详情</span>
        <div><el-button size="small" @click="close">关闭</el-button></div>
      </div>
      <el-form
        ref="elform"
        :model="form"
        :rules="rules"
        :inline="true"
        label-position="top"
      >
        <el-form-item label="单位部门">
          <el-input v-model="form.ssbm"></el-input>
        </el-form-item>
        <el-form-item label="盘查人">
          <el-input v-model="form.pcry"></el-input>
        </el-form-item>
        <el-form-item label="盘查车">
          <el-input v-model="form.pccl"></el-input>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>
<script setup>
import { qcckPost, qcckGet } from "@/api/qcckApi.js";
import * as MOSTY from "@/components/MyComponents/index";
import Pie from "./components/pie.vue";
import { selectDeptPage } from "@/api/user-manage";
import {
  ref,
  getCurrentInstance,
  onMounted,
  reactive,
  watch,
  watchEffect
} from "vue";
const { proxy } = getCurrentInstance();
const timeRange = ref([]); //
const listQuery = ref({
  pageCurrent: 1,
  pageSize: 10
}); //搜索表单
const tableData = ref([]); //表格数据
const total = ref(0);
const keyCount = ref(0); //tabel组件刷新值
const orgHeight = ref(); // 表格高度计算
const dialogFormVisible = ref(false);
const form = ref({}); //新增表单
const elform = ref(null); //新增表单容器
//表单验证
const rules = ref({
  name: [{ required: true, message: "请输入名称", trigger: "change" }]
});
const searchBox = ref(null); //搜索盒子
const loadingTable = ref(true); //表格加载状态
const tableHeight = ref(); // 表格高度
const countAllDefault = ref([]);
const countAll = ref([
  { name: "盘查人", type: "rysl", value: 0 },
  { name: "盘查车", type: "clsl", value: 0 }
]);

onMounted(() => {
  countAllDefault.value = JSON.parse(JSON.stringify(countAll.value));
  getDate(); //获取全部
  tabHeightFn();
  proxy.mittBus.on("mittFn", (data) => {
    keyCount.value = data;
  });
});

// 获取全部数据
function getDate() {
  console.log(timeRange.value);
  let params = {
    ssbmdm: listQuery.value.ssbmdm,
    pageSize: listQuery.value.pageSize,
    pageCurrent: listQuery.value.pageCurrent,
    kssj: timeRange.value.length > 0 ? timeRange.value[0] : "",
    jssj: timeRange.value.length > 0 ? timeRange.value[1] : ""
  };
  loadingTable.value = true;
  qcckPost(params, "/mosty-hczx/tbHcBpccl/getPctj")
    .then((res) => {
      countAll.value = JSON.parse(JSON.stringify(countAllDefault.value));
      loadingTable.value = false;
      if (!res) return;
      countAll.value.forEach((item) => {
        for (let key in res) {
          if (key == item.type) item.value = parseInt(res[key]);
        }
      });
      tableData.value = res.pageList.records || [];
      total.value = res.pageList.total;
    })
    .catch(() => {
      loadingTable.value = false;
    });
}

//处理时间
function handleTime(val) {
  listQuery.value.kssj = val ? val[0] : "";
  listQuery.value.jssj = val ? val[1] : "";
}

//点击查询
const handleFilter = () => {
  listQuery.value.pageCurrent = 1;
  getDate();
};
//点击重置
const reset = () => {
  listQuery.value = { pageCurrent: 1, pageSize: 10 };
  timeRange.value = [];
  getDate();
};

// pageSize 改变触发
const handleSizeChange = (currentSize) => {
  listQuery.value.pageSize = currentSize;
  getDate();
};

// 页码改变触发
const handleCurrentChange = (currentPage) => {
  listQuery.value.pageCurrent = currentPage;
  getDate();
};

const tabHeightFn = () => {
  tableHeight.value = window.innerHeight - 590;
  orgHeight.value = window.innerHeight - 192;
  window.onresize = function () {
    tabHeightFn();
  };
};

//关闭弹窗
function close() {
  dialogFormVisible.value = false;
  form.value = {};
}

watchEffect(() => {
  if (listQuery.value.ssbmdm) {
    getDate(); //获取全部
  }
});

//修改
function detail(row) {
  form.value = JSON.parse(JSON.stringify(row));
  dialogFormVisible.value = true;
}
</script>
<style lang="scss" scoped>
@import "~@/assets/css/layout.scss";
@import "~@/assets/css/element-plus.scss";
.table-box {
  margin-top: 10px;
}
.chart-box {
  height: 280px;
  display: flex;
  justify-content: center;
  align-items: center;
  .searchBox {
    width: 100%;
    height: 100%;
  }
}
.text-item {
  width: 180px;
  display: flex;
  justify-content: space-between;
  .title {
    width: 75px;
  }
  .text-color {
    color: rgb(181, 1, 1);
    text-align: center;
  }
  .dw {
    width: 30px;
  }
}
</style>
